#!/usr/bin/env bash

set -eu

bins=16
w=8
T=9
th=3
s=5
q=0.01
# multiscale=-1
# subpx_order=0
# add_noise="-add_noise"
add_noise=""
noise_a="0.2"
noise_b="0.2"
grayscale=""



while getopts :b:w:T:t:s:q:g:m:S:N:A:B: option
do 
    case "${option}" in
        b) bins=${OPTARG};;
        w) w=${OPTARG};;
        T) T=${OPTARG};;
        t) th=${OPTARG};;
        s) s=${OPTARG};;
        q) q=${OPTARG};;
        g)  if [ ${OPTARG} = "true" ]
            then
                grayscale="-g"
            elif [ ${OPTARG} = "false" ]
            then
                grayscale=""
            else
                echo "Error: grayscale option should be `true` or `false`, get ${OPTARG}"
                exit 1
            fi
            ;;
        # m)  multiscale=${OPTARG};;
        # S)  subpx_order=${OPTARG};;
        N)  if [ ${OPTARG} = "true" ]
            then
                add_noise="-add_noise"
            elif [ ${OPTARG} = "false" ]
            then
                add_noise=""
            else
                echo "Error: add_noise option should be `true` or `false`"
                exit 1
            fi
            ;;
        A) noise_a=${OPTARG};;
        B) noise_b=${OPTARG};;
            
            
        
    esac
done

img_0=${@:$OPTIND:1}
img_1=${@:$OPTIND+1:1}
out_curve=${@:$OPTIND+2:1}


#####################
# TEST in local env #
#####################
# main=./main.py
# img_0="frame0.png"
# img_1="frame1.png"

# img_0="/Users/yli/phd/ipol_noise_estimation/room_0.png"
# img_1="/Users/yli/phd/ipol_noise_estimation/room_1.png"

# img_0="/Users/yli/phd/ipol_noise_estimation/room_0.png"
# img_1="/Users/yli/phd/ipol_noise_estimation/room_1.png"

# img_0="/Users/yli/phd/ipol_noise_estimation/ens_0.png"
# img_1="/Users/yli/phd/ipol_noise_estimation/ens_1.png"


#####################
#      IPOL env     #
#####################
main=$bin/main.py

#####################
#   Main execution  #
#####################
command="python $main $img_0 $img_1 \
    -bins $bins \
    -q $quantile  \
    -s $s \
    -w $w \
    -T $T \
    -th $th \
    $grayscale \
    $add_noise \
    -noise_a $noise_a \
    -noise_b $noise_b"

$command

